dpkg-buildpackage(1)

NAME
dpkg-buildpackage - baue Binär- oder Quellpakete aus Quellen

ÜBERSICHT
dpkg-buildpackage [Optionen]

BESCHREIBUNG
dpkg-buildpackage ist ein Programm, das den Prozess des Bauens eines Debian-Paketes automatisiert. Es besteht aus den folgenden Schritten:

1.  Es bereitet die Bauumgebung vor, indem verschiedene Umgebungsvariablen gesetzt werden (siehe UMGEBUNGSVARIABLEN).

2.  Es prüft, dass Bauabhängigkeiten und -konflikte erfüllt sind (falls -d nicht angegeben ist).

3.  Falls ein spezielles Ziel mit der Option -T oder --target ausgewählt wurde, ruft es diese Ziel auf und endet hier. Andernfalls ruft es fakeroot debian/ rules clean auf, um den Bau-Baum zu bereinigen (falls -nc nicht angegeben ist).

4.  Es ruft dpkg-source auf, um das Quellpaket zu erstellen (falls nicht mit -b, -B oder -A ein rein-binärer Bau erbeten wurde).

5.  Es ruft debian/rules build, gefolgt von fakeroot debian/rules Programm-Ziel auf (falls nicht ein reiner Quellbau mit -S erbeten wurde). Beachten Sie, dass Programm-Ziel entweder binary (Standardfall, oder falls -b angegeben wurde) oder binary-arch (falls -B angegeben wurde) oder binary-indep (falls -A angegeben wurde) lautet.

6.  Es ruft gpg auf, um die .dsc-Datei zu signieren (falls vorhanden und -us nicht angegeben wurde).

7.  Es ruft dpkg-genchanges auf, um eine .changes-Datei zu erstellen. Viele Optionen von dpkg-buildpackage werden an dpkg-genchanges weitergeleitet.

8.  Es ruft gpg auf, um die .changes-Datei zu signieren (falls -uc nicht angegeben wurde).

9.  Falls -tc angegeben ist, wird fakeroot debian/rules clean erneut aufgerufen.

OPTIONEN

-b  Spezifiziert einen rein binären Bau, keine Quelldateien sollen gebaut und/oder vertrieben (im Sinne von verteilen) werden. Wird an dpkg-genchanges weitergegeben.

-B  Spezifiziert einen rein binären Bau, beschränkt auf architekturabhängige Pakete. Wird an dpkg-genchanges weitergegeben.

-A  Spezifiziert einen rein binären Bau, beschränkt auf architekturunabhängige Pakete. Wird an dpkg-genchanges weitergegeben.

-S  Spezifiziert einen reinen Bau der Quellen, keine Binärpakete müssen erstellt werden. Wird an dpkg-genchanges weitergegeben.

--target=Ziel
--target Ziel
-TZiel
    Ruft debian/rules Ziel auf, nachdem die Bauumgebung eingerichtet wurde und beendet den Paketbauprozess hier. Falls auch --as-root angegeben wurde, wird der Befehl mit root-Rechten ausgeführt (siehe -r). Beachten Sie, dass offizielle Ziele, bei denen die Debian-Richtlinien verlangen, dass Sie mit root-Rechten ausgeführt werden, diese Option nicht benötigen.

--as-root
    Ergibt nur mit --target einen Sinn. Erfordert, dass das Ziel mit Root-Rechten ausgeführt wird.

-si
-sa
-sd
-vVersion
-CÄnderungsbeschreibung
-mBetreueradresse
-eBetreueradresse
    Wird unverändert an dpkg-genchanges weitergegeben. Lesen Sie dessen Handbuchseite.

-aArchitektur
    Spezifiziert die Debian-Architektur, für die gebaut wird. Die Architektur der Maschine, auf der gebaut wird, wird automatisch bestimmt, und ist auch die Voreinstellung für die Gastgebermaschine (»host machine«). Falls sich die Host-Architektur von der Bau-Architektur unterscheidet (wie diese bei Cross-Kompilierung der Fall ist) und falls die Umgebungsvariable PKG_CONFIG_LIBDIR nicht gesetzt ist, dann wird sie auf einen Wert gesetzt, der für Cross-Kompilierung geeignet ist (»/usr/gnu-system-type/lib/pkgconfig/:/usr/share/pkgconfig«).

-tGNU-Systemtyp
    Spezifiziere den GNU-Systemtyp, für den wir bauen. Er kann anstelle von -a oder als Ergänzung verwandt werden, um den Standard GNU-Systemtyp der Ziel-Debian-Architektur zu überschreiben.

-jAufträge
    Anzahl an Aufträgen, die simultan laufen dürfen, äquivalent zu der Option von make(1) mit dem gleichen Namen. Fügt sich selbst zu der Umgebungsvariablen MAKEFLAGS hinzu, was dazu führen sollte, dass alle folgenden Aufrufe von make diese Option erben werden. Fügt auch parallel=Aufträge zu der Umgebungsvariablen DEB_BUILD_OPTIONS hinzu, was es debian/rules-Dateien erlaubt, diese Information für eigene Zwecke zu verwenden. Der Eintrag parallel=Aufträge in der Umgebungsvariablen DEB_BUILD_OPTIONS überschreibt den Wert von -j, falls diese Option angegeben ist.

-D  Prüfe Bauabhängigkeiten und -konflikte; Abbruch falls diese nicht erfüllt sind. Dies ist das Standardverhalten.

-d  Überprüfe Bauabhängigkeiten und -konflikte nicht.

-nc Bereinige den Quellbaum nicht (impliziert -b, falls ansonsten nichts aus -B, -A oder -S gewählt wurde).

-tc Den Quellbaum säubern (verwendet root-werde-Befehl debian/rules clean) nachdem das Paket gebaut wurde.

-rroot-werde-Befehl
    Wenn dpkg-buildpackage einen Teil des Bauprozesses als Root ausführen muss, stellt es dem auszführenden Befehl den root-werde-Befehl voran, falls dieser angegeben wurde. Andernfalls wird standardmäßig fakeroot verwendet, falls es vorhanden ist. Der root-werde-Befehl sollte der Name des Programmes im PATH sein und wird als Argumente den Namen des wirklich auszuführenden Befehles und dessen Argumente erhalten. root-werde-Befehl kann Parameter enthalten (die durch Leerzeichen voneinander getrennt sein müssen), aber keine Shell-Metazeichen. Typischerweise ist der root-werde-Befehl fakeroot, sudo, super oder really. su ist nicht geeignet, da es nur die Shell des Benutzers mit -c aufrufen kann, anstatt Argumente individuell zur Ausführung des Programms zu übergeben.

-Rrules-Datei
    Der Bau eines Debian-Pakets erfolgt gewöhnlich durch Aufruf von debian/rules als ein Befehl mit mehreren Standardparametern. Mit dieser Option ist es möglich, einen anderen Programmaufruf zum Bau des Paketes zu verwenden (es können durch Leerzeichen getrennte Parameter angegeben werden). Alternativ kann die Standard-debian/rules-Datei mit einem anderen Make-Programm ausgeführt werden (zum Beispiel durch die Verwendung von /usr/local/bin/make -f debian/rules als rules-Datei).

-psignier-Befehl
    Wenn dpkg-buildpackage GPG oder PGP zum Signieren einer Quellsteuerdatei ((.dsc)) oder einer .changes-Datei benötigt, wird es statt gpg den signier-Befehl ausführen (und dabei falls notwendig den PATH durchsuchen). Falls signier-Befehl seine Argumente im GPG- statt im PGP-Stil verlangt, sollten Sie die -sgpg-Option verwenden. signier-Befehl sollte keine Leerzeichen oder andere Metazeichen der Shell enthalten.

-kSchlüssel-id
    Geben Sie die Schlüssel-ID zur Signatur von Paketen an.

-us Das Quellpaket nicht signieren.

-uc Die .changes-Datei nicht signieren.

-i[Regexp]
-I[Muster]
-s[nsAkurKUR]
-z, -Z
    Wird unverändert an dpkg-source weitergegeben. Lesen Sie dessen Handbuchseite.

--admindir=Verz
--admindir Verz
    Ändert den Ablageort der dpkg-Datenbank. Der Standardort ist /var/lib/dpkg.

-h, --help
    Zeige den Bedienungshinweis und beende.

--version
    Gebe die Version aus und beende sich.

UMGEBUNGSVARIABLEN

  Von dpkg-architecture gesetzte Variablen
Beim Aufruf von dpkg-architecture werden die Parameter von -a und -t durchgereicht. Jede Variable, die von seiner Option -s ausgegeben wird, wird in die Bauumgebung integriert.

  Compiler-Schalter
Einige Umgebungsvariablen für Einstellungen der Optionen des Compilers und Linkers werden auf Standardwerte gesetzt, falls sie noch nicht in der Umgebung gesetzt wurden. Beachten Sie, dass dieser Mechanismus erst in dpkg-dev Version 1.14.17 eingeführt wurde und noch nicht alle rules-Dateien und Bauwerkzeuge diese Variablen berücksichtigen.

CFLAGS
    Optimierungs-Optionen, die an das Debian-Bausystem weitergegeben und vom Paketbausystem bei Bedarf überschrieben werden können/sollten (Vorgabewert: -g -O2 oder -g -O0 falls noopt in DEB_BUILD_OPTIONS angegeben ist). Das Überschreiben der Optionen kann dazu verwendet werden, explizit eine höhere Optimierungsstufe zu setzen oder um Compiler-Fehler zu umgehen, die nur bei einigen Optimierungsstufen auftreten (die letzte Optimierungsstufe »gewinnt«).

CFLAGS_APPEND
    Optimierungsoptionen, die an die Compiler-Schalter angehängt werden, die nicht vom Paket überschrieben werden dürfen (hauptsächlich zum Testen). Standardmäßig leer.

CXXFLAGS
    Identisch zu CFLAGS für C++-Quellen.

CXXFLAGS_APPEND
    Identisch zu CFLAGS_APPEND für C++-Quellen.

FFLAGS
    Identisch zu CFLAGS für Fortran-Quellen.

FFLAGS_APPEND
    Identisch zu CFLAGS_APPEND für Fortran-Quellen.

CPPFLAGS
    Präprozessor-Schalter, die an das Debian-Bausystem weitergegeben und vom Paketbausystem bei Bedarf überschrieben werden können/sollten (Vorgabewert: leer). Dieses Makro wird selten benutzt (die meisten Bausysteme verwenden einfach CFLAGS statt CPPFLAGS).

CPPFLAGS_APPEND
    Präprozessor-Schalter, die an die Präprozessor-Schalter angehängt werden, die nicht vom Paket überschrieben werden dürfen (hauptsächlich zum Testen). Standardmäßig leer.

LDFLAGS
    Optionen die beim Linken von Programmen oder Laufzeitbibliotheken an den Compiler weitergegeben werden (falls der Linker direkt aufgerufen wird, müssen -Wl und , aus diesen Optionen entfernt werden). Standardmäßig leer.

LDFLAGS_APPEND
    Optimierungs-Optionen, die an den Compiler beim Linken von Code angehängt werden und die nicht vom Paket überschrieben werden dürfen (hauptsächlich zum Testen). Standardmäßig leer.

FEHLER
Es sollte möglich sein, Leerzeichen und Metazeichen der Shell in und Anfangsargumente für root-werde-Befehl und signier-Befehl anzugeben.

ÜBERSETZUNG
Die deutsche Übersetzung wurde 2004, 2006-2009 von Helge Kreutzmann <debian@helgefjell.de>, 2007 von Florian Rehnisch <eixman@gmx.de> und 2008 von Sven Joachim <svenjoac@gmx.de> angefertigt. Diese Übersetzung ist Freie Dokumentation; lesen Sie die GNU General Public License Version 2 oder neuer für die Kopierbedingungen. Es gibt KEINE HAFTUNG.

SIEHE AUCH
dpkg-source(1), dpkg-architecture(1), dpkg-genchanges(1), fakeroot(1), gpg(1).

AUTOREN
Copyright © 1995-1996 Ian Jackson
Copyright © 2000 Wichert Akkerman
Copyright © 2007 Frank Lichtenheld
Copyright © 2008 Raphaël Hertzog

Dies ist Freie Software; lesen Sie die GNU General Public License Version 2 oder neuer für die Kopierbedingungen. Es gibt KEINE Haftung.